<?php
/**
 * @file
 * Spider Video Player module playlists.
 */

/**
 * Menu loader callback. Load playlists.
 */
function spider_video_player_playlists() {
  global $user;
  $form = array();
  $free_version = '
    <a href="http://web-dorado.com/files/fromSVPDrupal.php" target="_blank" style="color:red; text-decoration:none; float:right;">
      <img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/header.png" border="0" alt="www.web-dorado.com" width="215"><br />
    <div style="float:right;">' . t('Get the full version') . '&nbsp;&nbsp;&nbsp;&nbsp;</div>
    </a>';
  $form['fieldset_playlist_buttons'] = array(
    '#prefix' => $free_version,
    '#type' => 'fieldset',
  );
  $form['fieldset_playlist_buttons']['publish_playlist'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_playlists_publish'),
    '#value' => t('Publish'),
  );
  $form['fieldset_playlist_buttons']['unpublish_playlist'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_playlists_unpublish'),
    '#value' => t('Unpublish'),
  );
  $form['fieldset_playlist_buttons']['delete_playlist'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_playlists_delete'),
    '#value' => t('Delete'),
    '#attributes' => array('onclick' => 'if (!confirm(Drupal.t("Do you want to delete selected playlists?"))) {return false;}'),
    '#suffix' => l(t('New'), url('admin/settings/spider_video_player/playlists/edit', array('absolute' => TRUE))),
  );
  $form['fieldset_search_playlists_name'] = array(
    '#type' => 'fieldset',
    '#title' => t('Search playlists by name'),
    '#collapsible' => TRUE,
    '#collapsed' => ((variable_get('spider_video_player_search_playlists_name', '') == '') ? TRUE : FALSE),
  );
  $form['fieldset_search_playlists_name']['search_playlists_name'] = array(
    '#type' => 'textfield',
    '#size' => 25,
    '#default_value' => variable_get('spider_video_player_search_playlists_name', ''),
  );
  $form['fieldset_search_playlists_name']['search_playlists'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_search_playlists_name'),
    '#value' => t('Go'),
  );
  $form['fieldset_search_playlists_name']['reset_playlists'] = array(
    '#type' => 'submit',
    '#value' => t('Reset'),
    '#submit' => array('spider_video_player_reset_playlists_name'),
  );
  $header = array(
    theme('table_select_header_cell'),
    'id' => array('data' => t('ID'), 'field' => 'n.id'),
    'title' => array('data' => t('Title'), 'field' => 'n.title'),
    'number_of_videos' => array('data' => t('Number of Videos')),
    'published' => array('data' => t('Published'), 'field' => 'n.published'),
    'delete' => array('data' => t('Delete')),
  );
  $options = array();
  $additional_query = '';
  // Allow users edit only own playlists.
  if (($user->uid != 1) && (user_access('access Spider Video Player user playlists administration'))) {
    $additional_query .= "uid='" . $user->uid . "' OR uid=1 AND ";
  }
  $res = pager_query("SELECT id,title,videos,published FROM {spider_video_player_playlist} WHERE " . $additional_query . " title LIKE '%%" . variable_get('spider_video_player_search_playlists_name', '') . "%%'" . tablesort_sql($header), $limit = 20);
  while ($row = db_fetch_array($res)) {
    $playlist_id = $row['id'];
    if ($row['published']) {
      $publish_unpublish_png = 'publish.png';
      $publish_unpublish_function = 'unpublish';
    }
    else {
      $publish_unpublish_png = 'unpublish.png';
      $publish_unpublish_function = 'publish';
    }
    $checkbox = array(
      '#type' => 'checkbox',
      '#id' => 'checkbox' . $playlist_id,
      '#name' => 'checkbox' . $playlist_id,
    );
    $options[$playlist_id] = array(
      'checkboxes' => drupal_render($checkbox),
      'id' => $playlist_id,
      'title' => l($row['title'], url('admin/settings/spider_video_player/playlists/edit', array('query' => 'playlist_id=' . $playlist_id, 'absolute' => TRUE))),
      'number_of_videos' => (($row['videos'] != '') ? (count(explode(',', $row['videos'])) - 1) : 0),
      'published' => l(t('<img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/' . $publish_unpublish_png . '" />'), url('admin/settings/spider_video_player/playlists/' . $publish_unpublish_function, array('query' => 'playlist_id=' . $playlist_id, 'absolute' => TRUE)), array('html' => TRUE)),
      'delete' => l(t('Delete'), url('admin/settings/spider_video_player/playlists/delete', array('query' => 'playlist_id=' . $playlist_id, 'absolute' => TRUE))),
    );
  }
  $form['playlists_table'] = array(
    '#type' => 'fieldset',
    '#title' => t('Playlists'),
    '#value' => theme('table', $header, $options) . theme('pager'),
  );
  return $form;
}

/**
 * Search in playlists.
 */
function spider_video_player_search_playlists_name($form, &$form_state) {
  if ($form_state['values']['search_playlists_name'] != '') {
    variable_set('spider_video_player_search_playlists_name', $form_state['values']['search_playlists_name']);
  }
  else {
    variable_set('spider_video_player_search_playlists_name', '');
  }
}

/**
 * Reset playlists.
 */
function spider_video_player_reset_playlists_name($form, &$form_state) {
  variable_set('spider_video_player_search_playlists_name', '');
}

/**
 * Publish selected playlists.
 */
function spider_video_player_playlists_publish($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_playlist}")) {
    $result = db_query("SELECT id FROM {spider_video_player_playlist}");
    $flag = FALSE;
    while ($playlist_ids_col = db_fetch_array($result)) {
      $playlist_id = $playlist_ids_col['id'];
      if (isset($_POST['checkbox' . $playlist_id])) {
        $flag = TRUE;
        db_query("UPDATE {spider_video_player_playlist} SET published='%d' WHERE id='%d'", 1, $playlist_id);
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one playlist.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected playlists successfully published.'), 'status', FALSE);
    }
  }
}

/**
 * Publish playlist.
 */
function spider_video_player_playlist_publish() {
  if (isset($_GET['playlist_id'])) {
    $playlist_id = check_plain($_GET['playlist_id']);
    db_query("UPDATE {spider_video_player_playlist} SET published='%d' WHERE id='%d'", 1, $playlist_id);
  }
  drupal_set_message(t('Playlist successfully published.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/playlists', array('absolute' => TRUE)));
}

/**
 * Unpublish selected playlists.
 */
function spider_video_player_playlists_unpublish($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_playlist}")) {
    $result = db_query("SELECT id FROM {spider_video_player_playlist}");
    $flag = FALSE;
    while ($playlist_ids_col = db_fetch_array($result)) {
      $playlist_id = $playlist_ids_col['id'];
      if (isset($_POST['checkbox' . $playlist_id])) {
        $flag = TRUE;
        db_query("UPDATE {spider_video_player_playlist} SET published='%d' WHERE id='%d'", 0, $playlist_id);
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one playlist.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected playlists successfully unpublished.'), 'status', FALSE);
    }
  }
}

/**
 * Unpublish playlist.
 */
function spider_video_player_playlist_unpublish() {
  if (isset($_GET['playlist_id'])) {
    $playlist_id = check_plain($_GET['playlist_id']);
    db_query("UPDATE {spider_video_player_playlist} SET published='%d' WHERE id='%d'", 0, $playlist_id);
  }
  drupal_set_message(t('Playlist successfully unpublished.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/playlists', array('absolute' => TRUE)));
}

/**
 * Delete selected playlists.
 */
function spider_video_player_playlists_delete($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_playlist}")) {
    $result = db_query("SELECT id FROM {spider_video_player_playlist}");
    $flag = FALSE;
    while ($playlist_ids_col = db_fetch_array($result)) {
      $playlist_id = $playlist_ids_col['id'];
      if (isset($_POST['checkbox' . $playlist_id])) {
        $flag = TRUE;
        db_query("DELETE FROM {spider_video_player_playlist} WHERE id='%d'", $playlist_id);
        $value = db_query("SELECT id,playlist FROM {spider_video_player_form_table}");
        $ids_col = array();
        while ($a = db_fetch_array($value)) {
          $ids_col[$a['id']] = $a['playlist'];
        }
        foreach ($ids_col as $key => $playlist) {
          if (strpos($playlist, $playlist_id . ',')) {
            db_query("UPDATE {spider_video_player_form_table} SET playlist='%s' WHERE id='%d'", str_replace($playlist_id . ',', '', $playlist), $key);
          }
        }
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one playlist.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected playlists successfully deleted.'), 'status', FALSE);
    }
  }
}

/**
 * Delete playlist.
 */
function spider_video_player_playlist_delete() {
  if (isset($_GET['playlist_id'])) {
    $playlist_id = check_plain($_GET['playlist_id']);
    db_query("DELETE FROM {spider_video_player_playlist} WHERE id='%d'", $playlist_id);
    $result = db_query("SELECT id,playlist FROM {spider_video_player_form_table}");
        $ids_col = array();
        while ($a = db_fetch_array($result)) {
          $ids_col[$a['id']] = $a['playlist'];
        }
        foreach ($ids_col as $key => $playlist) {
          if (strpos($playlist, $playlist_id . ',')) {
            db_query("UPDATE {spider_video_player_form_table} SET playlist='%s' WHERE id='%d'", str_replace($playlist_id . ',', '', $playlist), $key);
          }
        }
  }
  drupal_set_message(t('Playlist successfully deleted.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/playlists', array('absolute' => TRUE)));
}

/**
 * Add or edit playlist.
 */
function spider_video_player_playlist_edit() {
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_change_video_type.js');
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_move_videos.js');
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_check_required.js');
  if (isset($_GET['playlist_id']) && (check_plain($_GET['playlist_id']) != '')) {
    $playlist_id = check_plain($_GET['playlist_id']);
    $value = db_query("SELECT * FROM {spider_video_player_playlist} WHERE id='%d'", $playlist_id);
    $row = db_fetch_array($value);
    $playlist_title = $row['title'];
    $added_videos = $row['videos'];
    $playlist_thumb = $row['thumb'];
    $playlist_published = $row['published'];
  }
  else {
    $playlist_id = '';
    $playlist_title = '';
    $added_videos = '';
    $playlist_thumb = '';
    $playlist_published = 1;
  }
  if (!isset($_GET['playlist_id'])) {
    variable_set('spider_video_player_videos_', '');
  }
  $added_videos .= variable_get('spider_video_player_videos_' . $playlist_id, '');
  $form = array();
  $form['playlist_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#required' => TRUE,
    '#default_value' => $playlist_title,
    '#size' => 35,
  );
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_open_iframe.js');
  $form['add_video_button'] = array(
    '#prefix' => '<div id="preview_iframe"></div><label><strong>' . t('Videos:') . '</strong></label><br />',
    '#type' => 'image_button',
    '#src' => drupal_get_path('module', 'spider_video_player') . '/images/add_but.png',
    '#attributes' => array('onclick' => 'spider_video_player_iframe("preview_iframe", "' . url('admin/settings/spider_video_player/playlists/add_video', array('query' => 'playlist_id=' . $playlist_id, 'absolute' => TRUE)) . '", "' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/close.png"); return false;'),
  );
  if ($added_videos != '') {
    $added_video_array = explode(',', $added_videos);
    $video_list = '
      <table>
        <tbody id="video_list">';
    foreach ($added_video_array as $key => $added_video) {
      if ($added_video != '') {
        $value = db_query("SELECT * FROM {spider_video_player_video} WHERE id='%d'", $added_video);
        $video_row = db_fetch_array($value);
        if ($video_row['url'] != '') {
          $video_url = $video_row['url'];
        }
        elseif ($video_row['urlHtml5'] != '') {
          $video_url = $video_row['urlHtml5'];
        }
        elseif ($video_row['urlHD'] != '') {
          $video_url = $video_row['urlHD'];
        }
        elseif ($video_row['urlHdHtml5'] != '') {
          $video_url = $video_row['urlHdHtml5'];
        }
        else {
          $video_url = '';
        }
        $video_list .= '
          <tr id="' . $key . '" video_id="' . $video_row['id'] . '">
            <td id="info_' . $key . '">
              <img height="100" align="left" src="' . $video_row['thumb'] . '" style="margin-right: 10px;">
              <b>' . $video_row['title'] . '</b>
              <p style="font-style: normal; color: rgb(102, 102, 102);">
                ' . t('Type') . ' : ' . $video_row['type'] . '
                <br />
                ' . t('Url') . ' : ' . $video_url . '
              </p>
            </td>
            <td id="X_' . $key . '" valign="middle" style="width: 50px;">
              <img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/delete.png" style="cursor: pointer; margin-left: 30px;" onclick=\'spider_video_player_remove_row("' . $key . '")\'>
            </td>
            <td id="up_' . $key . '" valign="middle" style="width: 20px;">
              <img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/up.png" style="cursor: pointer;" onclick=\'spider_video_player_up_row("' . $key . '")\'>
            </td>
            <td id="down_' . $key . '" valign="middle" style="width: 20px;">
              <img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/down.png" style="margin: 2px; cursor: pointer;" onclick=\'spider_video_player_down_row("' . $key . '")\'>
            </td>
          </tr>';
      }
    }
    $video_list .= '
        </tbody>
      </table>';
  }
  else {
    $video_list = '<table><tbody id="video_list"></tbody></table>';
  }
  $form['added_videos'] = array(
    '#prefix' => $video_list,
    '#type' => 'hidden',
    '#value' => $added_videos,
    '#id' => 'added_videos',
  );
  $form['thumb'] = array(
    '#prefix' => '
      <div id="image_iframe" style="position:fixed; width:100%; height:100%; top:50px; left:0; display:none">
        <div id="div_black" style="position:fixed; top:0; left:0; width:100%; height:100%; background-color:#000000; opacity:0.80; z-index:10000000;"></div>
        <div id="div_content" style="position:relative; top:50px; width:570px; height:500px; margin:0 auto;z-index:10000001;background-color:#FFFFFF;">
          <iframe width="570" height="500" src="' . url('admin/settings/spider_video_player/image_upload', array('absolute' => TRUE)) . '"></iframe>
        </div>
        <div onclick=\'spider_video_player_image_upload("none")\' style=\'position:fixed; z-index:10000002; right:20%; top:100px; width:32px; height:32px; background-image:url("' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/close.png"); \'></div>
      </div>
      <br />
      <strong>' . t('Thumb:') . '</strong>
      <br />' . l(t('Select Image'), '', array('attributes' => array('onclick' => 'spider_video_player_image_upload("");return false;'))),
    '#type' => 'hidden',
    '#value' => $playlist_thumb,
    '#id' => 'thumb',
    '#suffix' => '<br />' . l(t('Remove Image'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_image(); return false;'))) . '
      <br /><img id="imagebox" ' . (($playlist_thumb != '') ? 'style="max-height:150px" src="' . $playlist_thumb . '"' : '') . '/><br />',
  );
  $form['playlist_published'] = array(
    '#type' => 'radios',
    '#title' => t('Published'),
    '#default_value' => $playlist_published,
    '#options' => array('1' => t('Yes'), '0' => t('No')),
  );
  $form['playlist_save'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('spider_video_player_playlist_save'),
    '#attributes' => array('onclick' => 'return spider_video_player_check_required("edit-playlist-title", "", "");'),
  );
  $form['playlist_apply'] = array(
    '#type' => 'submit',
    '#value' => t('Apply'),
    '#submit' => array('spider_video_player_playlist_apply'),
    '#attributes' => array('onclick' => 'return spider_video_player_check_required("edit-playlist-title", "", "");'),
  );
  $form['playlist_cancel'] = array(
    '#type' => 'submit',
    '#value' => t('Cancel'),
    '#attributes' => array('onclick' => 'document.getElementById("edit-playlist-title").setAttribute("style", "color:rgba(255, 0, 0, 0)");document.getElementById("edit-playlist-title").setAttribute("value", "cancel");'),
    '#submit' => array('spider_video_player_playlist_cancel'),
  );
  return $form;
}

/**
 * Save playlist.
 */
function spider_video_player_playlist_save($form, &$form_state) {
  global $user;
  $playlist_title = $form_state['values']['playlist_title'];
  $added_videos = check_plain($_POST['added_videos']);
  $playlist_thumb = check_plain($_POST['thumb']);
  $playlist_published = $form_state['values']['playlist_published'];
  if (isset($_GET['playlist_id']) && (check_plain($_GET['playlist_id']) != '')) {
    $playlist_id = check_plain($_GET['playlist_id']);
    db_query("UPDATE {spider_video_player_playlist} SET 
      uid='%d',title='%s',videos='%s',thumb='%s',published='%d'
      WHERE id='%d'", $user->uid, $playlist_title, $added_videos, $playlist_thumb, $playlist_published, $playlist_id);
    variable_set('spider_video_player_videos_' . $playlist_id, '');
  }
  else {
    db_query('INSERT INTO {spider_video_player_playlist}
        (uid,title,videos,thumb,published) VALUES (' . $user->uid . ',"' . $playlist_title . '","' . $added_videos . '","' . $playlist_thumb . '","' . $playlist_published .'")');
    variable_set('spider_video_player_playlist_id', '');
  }
  drupal_set_message(t('Your playlist successfully saved.'), 'status', FALSE);
  $form_state['redirect'] = url('admin/settings/spider_video_player/playlists', array('absolute' => TRUE));
}

/**
 * Apply playlist.
 */
function spider_video_player_playlist_apply($form, &$form_state) {
  global $user;
  $playlist_title = $form_state['values']['playlist_title'];
  $added_videos = check_plain($_POST['added_videos']);
  $playlist_thumb = check_plain($_POST['thumb']);
  $playlist_published = $form_state['values']['playlist_published'];
  if (isset($_GET['playlist_id']) && (check_plain($_GET['playlist_id']) != '')) {
    $playlist_id = check_plain($_GET['playlist_id']);
    db_query("UPDATE {spider_video_player_playlist} SET 
      uid='%d',title='%s',videos='%s',thumb='%s',published='%d'
      WHERE id='%d'", $user->uid, $playlist_title, $added_videos, $playlist_thumb, $playlist_published, $playlist_id);
    drupal_set_message(t('Your playlist successfully updated.'), 'status', FALSE);
    variable_set('spider_video_player_videos_' . $playlist_id, '');
  }
  else {
    db_query('INSERT INTO {spider_video_player_playlist}
        (uid,title,videos,thumb,published) VALUES (' . $user->uid . ',"' . $playlist_title . '","' . $added_videos . '","' . $playlist_thumb . '","' . $playlist_published .'")');
    $playlist_id = db_result(db_query("SELECT MAX(id) FROM {spider_video_player_playlist}"));
    drupal_set_message(t('Your playlist successfully saved.'), 'status', FALSE);
    variable_set('spider_video_player_playlist_id', '');
  }
  $form_state['redirect'] = url('admin/settings/spider_video_player/playlists/edit', array('query' => 'playlist_id=' . $playlist_id, 'absolute' => TRUE));
}

/**
 * Cancel playlist save.
 */
function spider_video_player_playlist_cancel($form, &$form_state) {
  $form_state['redirect'] = url('admin/settings/spider_video_player/playlists', array('absolute' => TRUE));
}
