<?php
/**
 * @file
 * Spider Video Player module videos.
 */

/**
 * Menu loader callback. Load videos.
 */
function spider_video_player_videos() {
  global $user;
  $form = array();
  $free_version = '
    <a href="http://web-dorado.com/files/fromSVPDrupal.php" target="_blank" style="color:red; text-decoration:none; float:right;">
      <img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/header.png" border="0" alt="www.web-dorado.com" width="215"><br />
    <div style="float:right;">' . t('Get the full version') . '&nbsp;&nbsp;&nbsp;&nbsp;</div>
    </a>';
  $form['fieldset_video_buttons'] = array(
    '#prefix' => $free_version,
    '#type' => 'fieldset',
  );
  $form['fieldset_video_buttons']['publish_video'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_videos_publish'),
    '#value' => t('Publish'),
  );
  $form['fieldset_video_buttons']['unpublish_video'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_videos_unpublish'),
    '#value' => t('Unpublish'),
  );
  $form['fieldset_video_buttons']['delete_video'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_videos_delete'),
    '#value' => t('Delete'),
    '#attributes' => array('onclick' => 'if (!confirm(Drupal.t("Do you want to delete selected videos?"))) {return false;}'),
    '#suffix' => l(t('New'), url('admin/settings/spider_video_player/videos/edit', array('absolute' => TRUE))),
  );
  // Search videos by name.
  $form['fieldset_search_videos_name'] = array(
    '#type' => 'fieldset',
    '#title' => t('Search videos by name'),
    '#collapsible' => TRUE,
    '#collapsed' => ((variable_get('spider_video_player_search_videos_name', '') == '') ? TRUE : FALSE),
  );
  $form['fieldset_search_videos_name']['search_videos_name'] = array(
    '#type' => 'textfield',
    '#size' => 25,
    '#default_value' => variable_get('spider_video_player_search_videos_name', ''),
  );
  $form['fieldset_search_videos_name']['search_videos'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_search_videos_name'),
    '#value' => t('Go') . ' ',
  );
  $form['fieldset_search_videos_name']['reset_videos'] = array(
    '#type' => 'submit',
    '#value' => t('Reset') . ' ',
    '#submit' => array('spider_video_player_reset_videos_name'),
  );
  // Search videos by playlist.
  $form['fieldset_search_videos_by_playlist'] = array(
    '#type' => 'fieldset',
    '#title' => t('Search videos by playlist'),
    '#collapsible' => TRUE,
    '#collapsed' => ((variable_get('spider_video_player_search_videos_by_playlist', '') == '') ? TRUE : FALSE),
  );
  $result = db_query("SELECT id,title FROM {spider_video_player_playlist} ORDER BY title");
  $select_playlist = array();
  $select_playlist[0] = t('-Select Playlist-');
  while ($a = db_fetch_array($result)) {
    $select_playlist[$a['id']] = $a['title'];
  }
  $form['fieldset_search_videos_by_playlist']['search_videos_by_playlist_select'] = array(
    '#type' => 'select',
    '#options' => $select_playlist,
    '#default_value' => variable_get('spider_video_player_search_videos_by_playlist', ''),
  );
  $form['fieldset_search_videos_by_playlist']['search_videos_by_playlist'] = array(
    '#type' => 'submit',
    '#submit' => array('spider_video_player_search_videos_by_playlist'),
    '#value' => t('Go'),
  );
  $form['fieldset_search_videos_by_playlist']['reset_videos_by_playlist'] = array(
    '#type' => 'submit',
    '#value' => t('Reset'),
    '#submit' => array('spider_video_player_reset_videos_by_playlist'),
  );
  $header = array(
    theme('table_select_header_cell'),
    'id' => array('data' => t('ID'), 'field' => 'id'),
    'title' => array('data' => t('Title'), 'field' => 'title'),
    'type' => array('data' => t('Type'), 'field' => 'type'),
    'url' => array('data' => t('Url'), 'field' => 'url'),
    'urlHD' => array('data' => t('UrlHD'), 'field' => 'urlHD'),
    'thumb' => array('data' => t('Thumb'), 'field' => 'thumb'),
    'published' => array('data' => t('Published'), 'field' => 'published'),
    'delete' => array('data' => t('Delete')),
  );
  $options = array();
  $additional_query = '';
  if (variable_get('spider_video_player_search_videos_by_playlist', '') != '') {
    $videos = db_result(db_query("SELECT videos FROM {spider_video_player_playlist} WHERE id='%d'", variable_get('spider_video_player_search_videos_by_playlist', '')));
    $videos_array = explode(',', $videos);
    foreach ($videos_array as $video) {
      if ($video != '') {
        $additional_query .= "id='" . $video . "' OR ";
      }
    }
    // Replace last OR to AND.
    if ($additional_query != '') {
      $additional_query = substr($additional_query, 0, strlen($additional_query) - 3) . 'AND ';
    }
  }
  // Allow users edit only own videos.
  if (($user->uid != 1) && (user_access('access Spider Video Player user videos administration'))) {
    $additional_query .= "uid='" . $user->uid . "' OR uid=1 AND ";
  }
  $res = pager_query("SELECT id,title,url,urlHD,urlHtml5,urlHdHtml5,type,thumb,published FROM {spider_video_player_video} WHERE " . $additional_query . " title LIKE '%%" . variable_get('spider_video_player_search_videos_name', '') . "%%'" . tablesort_sql($header), $limit = 20);
  while ($row = db_fetch_array($res)) {
    $video_id = $row['id'];
    if ($row['published']) {
      $publish_unpublish_png = 'publish.png';
      $publish_unpublish_function = 'unpublish';
    }
    else {
      $publish_unpublish_png = 'unpublish.png';
      $publish_unpublish_function = 'publish';
    }
    $checkbox = array(
      '#type' => 'checkbox',
      '#id' => 'checkbox' . $video_id,
      '#name' => 'checkbox' . $video_id,
    );
    $options[$video_id] = array(
      'checkboxes' => drupal_render($checkbox),
      'id' => $video_id,
      'title' => l($row['title'], url('admin/settings/spider_video_player/videos/edit', array('query' => 'video_id=' . $video_id, 'absolute' => TRUE))),
      'type' => $row['type'],
      'url' => (($row['url'] != '') ? $row['url'] : $row['urlHtml5']),
      'urlHD' => (($row['urlHD'] != '') ? $row['urlHD'] : $row['urlHdHtml5']),
      'thumb' => (($row['thumb'] != '') ? '<img width="50" title="' . $row['thumb'] . '" src="' . $row['thumb'] . '" />' : ''),
      'published' => l(t('<img src="' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/' . $publish_unpublish_png . '" />'), url('admin/settings/spider_video_player/videos/' . $publish_unpublish_function, array('query' => 'video_id=' . $video_id, 'absolute' => TRUE)), array('html' => TRUE)),
      'delete' => l(t('Delete'), url('admin/settings/spider_video_player/videos/delete', array('query' => 'video_id=' . $video_id, 'absolute' => TRUE))),
    );
  }
  $form['videos_table'] = array(
    '#type' => 'fieldset',
    '#title' => t('Videos'),
    '#value' => theme('table', $header, $options) . theme('pager'),
  );
  return $form;
}

/**
 * Search videos by name.
 */
function spider_video_player_search_videos_name($form, &$form_state) {
  if ($form_state['values']['search_videos_name'] != '') {
    variable_set('spider_video_player_search_videos_name', $form_state['values']['search_videos_name']);
  }
  else {
    variable_set('spider_video_player_search_videos_name', '');
  }
}

/**
 * Reset videos.
 */
function spider_video_player_reset_videos_name($form, &$form_state) {
  variable_set('spider_video_player_search_videos_name', '');
}

/**
 * Search videos by playlist.
 */
function spider_video_player_search_videos_by_playlist($form, &$form_state) {
  if ($form_state['values']['search_videos_by_playlist_select'] != '') {
    variable_set('spider_video_player_search_videos_by_playlist', $form_state['values']['search_videos_by_playlist_select']);
  }
  else {
    variable_set('spider_video_player_search_videos_by_playlist', '');
  }
}

/**
 * Reset videos.
 */
function spider_video_player_reset_videos_by_playlist($form, &$form_state) {
  variable_set('spider_video_player_search_videos_by_playlist', '');
}
/**
 * Publish selected videos.
 */
function spider_video_player_videos_publish($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_video}")) {
    $result = db_query("SELECT id FROM {spider_video_player_video}");
    $flag = FALSE;
    while ($video_ids_col = db_fetch_array($result)) {
      $video_id = $video_ids_col['id'];
      if (isset($_POST['checkbox' . $video_id])) {
        $flag = TRUE;
        db_query("UPDATE {spider_video_player_video} SET published='%d' WHERE id='%d'", 1, $video_id);
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one video.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected videos successfully published.'), 'status', FALSE);
    }
  }
}

/**
 * Publish video.
 */
function spider_video_player_video_publish() {
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    db_query("UPDATE {spider_video_player_video} SET published='%d' WHERE id='%d'", 1, $video_id);
  }
  drupal_set_message(t('Video successfully published.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/videos', array('absolute' => TRUE)));
}

/**
 * Unpublish selected videos.
 */
function spider_video_player_videos_unpublish($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_video}")) {
    $result = db_query("SELECT id FROM {spider_video_player_video}");
    $flag = FALSE;
    while ($video_ids_col = db_fetch_array($result)) {
      $video_id = $video_ids_col['id'];
      if (isset($_POST['checkbox' . $video_id])) {
        $flag = TRUE;
        db_query("UPDATE {spider_video_player_video} SET published='%d' WHERE id='%d'", 0, $video_id);
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one video.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected videos successfully unpublished.'), 'status', FALSE);
    }
  }
}

/**
 * Unpublish video.
 */
function spider_video_player_video_unpublish() {
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    db_query("UPDATE {spider_video_player_video} SET published='%d' WHERE id='%d'", 0, $video_id);
  }
  drupal_set_message(t('Video successfully unpublished.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/videos', array('absolute' => TRUE)));
}

/**
 * Delete selected videos.
 */
function spider_video_player_videos_delete($form, &$form_state) {
  if (db_query("SELECT id FROM {spider_video_player_video}")) {
    $result = db_query("SELECT id FROM {spider_video_player_video}");
    $flag = FALSE;
    while ($video_ids_col = db_fetch_array($result)) {
      $video_id = $video_ids_col['id'];
      if (isset($_POST['checkbox' . $video_id])) {
        $flag = TRUE;
        db_query("DELETE FROM {spider_video_player_video} WHERE id='%d'", $video_id);
        $value = db_query("SELECT id,videos FROM {spider_video_player_playlist}");
        while ($a = db_fetch_array($value)) {
          if (strpos($a['playlist'], $video_id . ',')) {
            db_query("UPDATE {spider_video_player_playlist} SET videos='%s' WHERE id='%d'", str_replace($video_id . ',', '', $a['playlist']), $a['id']);
          }
        }
      }
    }
    if ($flag == FALSE) {
      drupal_set_message(t('You must select at least one video.'), 'warning', FALSE);
    }
    else {
      drupal_set_message(t('Selected videos successfully deleted.'), 'status', FALSE);
    }
  }
}

/**
 * Delete video.
 */
function spider_video_player_video_delete() {
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    db_query("DELETE FROM {spider_video_player_video} WHERE id='%d'", $video_id);
    $value = db_query("SELECT id,videos FROM {spider_video_player_playlist}");
    while ($a = db_fetch_array($value)) {
      if (strpos($a['playlist'], $video_id . ',')) {
        db_query("UPDATE {spider_video_player_playlist} SET videos='%s' WHERE id='%d'", str_replace($video_id . ',', '', $a['playlist']), $a['id']);
      }
    }
  }
  drupal_set_message(t('Video successfully deleted.'), 'status', FALSE);
  drupal_goto(url('admin/settings/spider_video_player/videos', array('absolute' => TRUE)));
}

/**
 * Add or edit video.
 */
function spider_video_player_video_edit() {
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_change_video_type.js');
  drupal_add_js(drupal_get_path('module', 'spider_video_player') . '/js/spider_video_player_check_required.js');
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    $value = db_query("SELECT * FROM {spider_video_player_video} WHERE id='%d'", $video_id);
    $row = db_fetch_array($value);
    $video_title = $row['title'];
    $video_type = $row['type'];
    $video_thumb = $row['thumb'];
    $video_params = explode('#***#', $row['params']);
    $video_published = $row['published'];
  }
  else {
    $video_id = '';
    $video_title = '';
    $video_type = 'http';
    $video_http_url = '';
    $video_http_url_html5 = '';
    $video_http_url_hd = '';
    $video_http_url_hd_html5 = '';
    $video_youtube_url = '';
    $video_fms_url = '';
    $video_rtmp_url = '';
    $video_rtmp_url_hd = '';
    $video_thumb = '';
    $video_params = 'new';
    $video_published = 1;
  }
  switch ($video_type) {
    case 'http':
      drupal_add_js('spider_video_player_change_video_type("edit-video-type-http");', 'inline', 'footer');
      if (isset($_GET['video_id'])) {
        $video_http_url = $row['url'];
        $video_http_url_html5 = $row['urlHtml5'];
        $video_http_url_hd = $row['urlHD'];
        $video_http_url_hd_html5 = $row['urlHdHtml5'];
        $video_youtube_url = '';
        $video_fms_url = '';
        $video_rtmp_url = '';
        $video_rtmp_url_hd = '';
      }
      break;

    case 'youtube':
      drupal_add_js('spider_video_player_change_video_type("edit-video-type-youtube");', 'inline', 'footer');
      if (isset($_GET['video_id'])) {
        $video_http_url = '';
        $video_http_url_html5 = '';
        $video_http_url_hd = '';
        $video_http_url_hd_html5 = '';
        $video_youtube_url = $row['url'];
        $video_fms_url = '';
        $video_rtmp_url = '';
        $video_rtmp_url_hd = '';
      }
      break;

    case 'rtmp':
      drupal_add_js('spider_video_player_change_video_type("edit-video-type-rtmp");', 'inline', 'footer');
      if (isset($_GET['video_id'])) {
        $video_http_url = '';
        $video_http_url_html5 = '';
        $video_http_url_hd = '';
        $video_http_url_hd_html5 = '';
        $video_youtube_url = '';
        $video_fms_url = $row['fmsUl'];
        $video_rtmp_url = $row['url'];
        $video_rtmp_url_hd = $row['urlHD'];
      }
      break;
  }
  $form = array();
  $form['video_title'] = array(
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#required' => TRUE,
    '#default_value' => $video_title,
    '#size' => 35,
  );
  $form['video_type'] = array(
    '#type' => 'radios',
    '#title' => t('Type'),
    '#default_value' => $video_type,
    '#attributes' => array('onmouseup' => 'spider_video_player_change_video_type(this.id);'),
    '#options' => array(
      'http' => t('http'),
      'youtube' => t('youtube'),
      'rtmp' => t('rtmp'),
    ),
    '#suffix' => '
      <div id="video_iframe" style="position:fixed; width:100%; height:100%; top:50px; left:0; display:none">
        <div id="div_black" style="position:fixed; top:0; left:0; width:100%; height:100%; background-color:#000000; opacity:0.80; z-index:10000000;"></div>
        <div id="div_content" style="position:relative; top:50px; width:570px; height:500px; margin:0 auto;z-index:10000001;background-color:#FFFFFF;">
          <iframe width="570" height="500" src="' . url('admin/settings/spider_video_player/video_upload', array('absolute' => TRUE)) . '"></iframe>
        </div>
        <div onclick=\'spider_video_player_file_upload("none")\' style=\'position:fixed; z-index:10000002; right:20%; top:100px; width:32px; height:32px; background-image:url("' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/close.png"); \'></div>
      </div>',
  );
  $form['video_type_hidden'] = array(
    '#type' => 'hidden',
    '#id' => 'video_type_hidden',
  );
  $form['url_http'] = array(
    '#prefix' => '
      <div id="video_http">
      <br />
      <strong>' . t('Url:') . '</strong>
      <br />' . l((($video_http_url != '') ? $video_http_url : t('Select Video')), '', array('attributes' => array('onclick' => 'spider_video_player_set_video_type("url_http");spider_video_player_file_upload("");return false;', 'id' => 'url_http_link'))),
    '#type' => 'hidden',
    '#value' => $video_http_url,
    '#id' => 'url_http',
    '#suffix' => '<br />' . l(t('Remove Video'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_video("url_http"); return false;'))),
  );
  $form['urlHtml5'] = array(
    '#prefix' => '
      <br />
      <strong>' . t('Url(HTML5):') . '</strong>
      <br />' . l((($video_http_url_html5 != '') ? $video_http_url_html5 : t('Select Video')), '', array('attributes' => array('onclick' => 'spider_video_player_set_video_type("urlHtml5");spider_video_player_file_upload("");return false;', 'id' => 'urlHtml5_link'))) . '
      <div class="description">' . t('Allowed file extensions - MP4, WebM, Ogg') . '</div>',
    '#type' => 'hidden',
    '#value' => $video_http_url_html5,
    '#id' => 'urlHtml5',
    '#suffix' => l(t('Remove Video'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_video("urlHtml5"); return false;'))),
  );
  $form['urlHD'] = array(
    '#prefix' => '
      <br />
      <strong>' . t('UrlHD:') . '</strong>
      <br />' . l((($video_http_url_hd != '') ? $video_http_url_hd : t('Select Video')), '', array('attributes' => array('onclick' => 'spider_video_player_set_video_type("urlHD");spider_video_player_file_upload("");return false;', 'id' => 'urlHD_link'))),
    '#type' => 'hidden',
    '#value' => $video_http_url_hd,
    '#id' => 'urlHD',
    '#suffix' => '<br />' . l(t('Remove Video'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_video("urlHD"); return false;'))),
  );
  $form['urlHdHtml5'] = array(
    '#prefix' => '
      <br />
      <strong>' . t('UrlHD(HTML5):') . '</strong>
      <br />' . l((($video_http_url_hd_html5 != '') ? $video_http_url_hd_html5 : t('Select Video')), '', array('attributes' => array('onclick' => 'spider_video_player_set_video_type("urlHdHtml5");spider_video_player_file_upload("");return false;', 'id' => 'urlHdHtml5_link'))) . '
      <div class="description">' . t('Allowed file extensions - MP4, WebM, Ogg') . '</div>',
    '#type' => 'hidden',
    '#value' => $video_http_url_hd_html5,
    '#id' => 'urlHdHtml5',
    '#suffix' => l(t('Remove Video'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_video("urlHdHtml5"); return false;'))) . '</div>',
  );
  $form['video_youtube_url'] = array(
    '#prefix' => '<div id="video_youtube">',
    '#type' => 'textfield',
    '#title' => t('Url'),
    '#default_value' => $video_youtube_url,
    '#size' => 35,
    '#suffix' => '</div>',
  );
  $form['video_fmsUrl'] = array(
    '#prefix' => '<div id="video_rtmp">',
    '#type' => 'textfield',
    '#title' => t('fmsUrl'),
    '#default_value' => $video_fms_url,
    '#size' => 35,
  );
  $form['video_rtmp_Url'] = array(
    '#type' => 'textfield',
    '#title' => t('Url'),
    '#default_value' => $video_rtmp_url,
    '#size' => 35,
  );
  $form['video_rtmp_urlHD'] = array(
    '#type' => 'textfield',
    '#title' => t('UrlHD'),
    '#default_value' => $video_rtmp_url_hd,
    '#size' => 35,
    '#suffix' => '</div>',
  );
  $form['video_radio_type_hidden'] = array(
    '#type' => 'hidden',
    '#value' => $video_type,
    '#id' => 'video_radio_type_hidden',
  );
  $form['thumb'] = array(
    '#prefix' => '
      <div id="image_iframe" style="position:fixed; width:100%; height:100%; top:50px; left:0; display:none">
        <div id="div_black" style="position:fixed; top:0; left:0; width:100%; height:100%; background-color:#000000; opacity:0.80; z-index:10000000;"></div>
        <div id="div_content" style="position:relative; top:50px; width:570px; height:500px; margin:0 auto;z-index:10000001;background-color:#FFFFFF;">
          <iframe width="570" height="500" src="' . url('admin/settings/spider_video_player/image_upload', array('absolute' => TRUE)) . '"></iframe>
        </div>
        <div onclick=\'spider_video_player_image_upload("none")\' style=\'position:fixed; z-index:10000002; right:20%; top:100px; width:32px; height:32px; background-image:url("' . base_path() . drupal_get_path('module', 'spider_video_player') . '/images/close.png"); \'></div>
      </div>
      <strong>' . t('Thumb:') . '</strong>
      <br />' . l(t('Select Image'), '', array('attributes' => array('onclick' => 'spider_video_player_image_upload("");return false;'))),
    '#type' => 'hidden',
    '#value' => $video_thumb,
    '#id' => 'thumb',
    '#suffix' => '<br />' . l(t('Remove Image'), '', array('attributes' => array('onclick' => 'spider_video_player_remove_image(); return false;'))) . '
      <br /><img id="imagebox" ' . (($video_thumb != '') ? 'height="150" src="' . $video_thumb . '"' : '') . '/><br />',
  );
  $required = '';
  if ($video_params == 'new') {
    $result = db_query("SELECT id FROM {spider_video_player_tag} WHERE published='%d' ORDER BY ordering", 1);
    $tag_ids = array();
    while ($a = db_fetch_array($result)) {
      $tag_ids[] = $a['id'];
    }
    foreach ($tag_ids as $tag_id) {
      $value = db_query("SELECT * FROM {spider_video_player_tag} WHERE id='%d'", $tag_id);
      $row = db_fetch_array($value);
      $form['video_param_' . $tag_id] = array(
        '#type' => 'textfield',
        '#title' => $row['name'],
        '#required' => (($row['required'] == 1) ? TRUE : FALSE),
        '#size' => 35,
      );
      if ($row['required'] == 1) {
        $required .= $tag_id . ',';
      }
    }
  }
  else {
    foreach ($video_params as $video_param) {
      if ($video_param != '') {
        $video_tag = explode('#===#', $video_param);
        if ($video_tag[0] != '') {
          $value = db_query("SELECT * FROM {spider_video_player_tag} WHERE published='%d' AND id='%d'", 1, $video_tag[0]);
          $row = db_fetch_array($value);
          if ($row) {
            $form['video_param_' . $video_tag[0]] = array(
              '#type' => 'textfield',
              '#title' => $row['name'],
              '#default_value' => $video_tag[1],
              '#required' => (($row['required'] == 1) ? TRUE : FALSE),
              '#size' => 35,
            );
            if ($row['required'] == 1) {
              $required .= $video_tag[0] . ',';
            }
          }
        }
      }
    }
  }
  $form['required_hidden'] = array(
    '#type' => 'hidden',
    '#value' => $required,
    '#id' => 'required_hidden',
  );
  $form['video_published'] = array(
    '#type' => 'radios',
    '#title' => t('Published'),
    '#default_value' => $video_published,
    '#options' => array('1' => t('Yes'), '0' => t('No')),
  );
  $form['video_save'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('spider_video_player_video_save'),
    '#attributes' => array('onclick' => 'return spider_video_player_check_required("edit-video-title", "edit-video-param-", "required_hidden");'),
  );
  $form['video_apply'] = array(
    '#type' => 'submit',
    '#value' => t('Apply'),
    '#submit' => array('spider_video_player_video_apply'),
    '#attributes' => array('onclick' => 'return spider_video_player_check_required("edit-video-title", "edit-video-param-", "required_hidden");'),
    '#suffix' => l(t('Cancel'), url('admin/settings/spider_video_player/videos/cancel', array('absolute' => TRUE))),
  );
  return $form;
}

/**
 * Save video.
 */
function spider_video_player_video_save($form, &$form_state) {
  global $user;
  $video_title = $form_state['values']['video_title'];
  $video_type = check_plain($_POST['video_radio_type_hidden']);
  switch ($video_type) {
    case 'http':
      $video_url = check_plain($_POST['url_http']);
      $video_url_hd = check_plain($_POST['urlHD']);
      $video_url_html5 = check_plain($_POST['urlHtml5']);
      $video_url_hd_html5 = check_plain($_POST['urlHdHtml5']);
      $video_fms_url = '';
      break;

    case 'youtube':
      $video_url = check_plain($_POST['video_youtube_url']);
      $video_url_hd = '';
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = '';
      break;

    case 'rtmp':
      $video_url = check_plain($_POST['video_rtmp_Url']);
      $video_url_hd = check_plain($_POST['video_rtmp_urlHD']);
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = check_plain($_POST['video_fmsUrl']);
      break;

    default:
      $video_url = '';
      $video_url_hd = '';
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = '';
      break;
  }
  $video_thumb = check_plain($_POST['thumb']);
  $result = db_query("SELECT id FROM {spider_video_player_tag} WHERE published='%d' ORDER BY ordering", 1);
  $tag_ids = array();
  while ($a = db_fetch_array($result)) {
    $tag_ids[] = $a['id'];
  }
  $video_params = '';
  foreach ($tag_ids as $tag_id) {
    $video_params .= $tag_id . '#===#' . $form_state['values']['video_param_' . $tag_id] . '#***#';
  }
  $video_published = $form_state['values']['video_published'];
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    db_query("UPDATE {spider_video_player_video} SET 
      uid='%d',
      title='%s',
      type='%s',
      urlHtml5='%s',
      urlHdHtml5='%s',
      fmsUrl='%s',
      url='%s',
      urlHD='%s',
      params='%s',
      thumb='%s',
      published='%d' WHERE id='%d'", 
      $user->uid,
      $video_title,
      $video_type,
      $video_url_html5,
      $video_url_hd_html5,
      $video_fms_url,
      $video_url,
      $video_url_hd,
      $video_params,
      $video_thumb,
      $video_published,
      $video_id);
  }
  else {
    db_query('INSERT INTO {spider_video_player_video} (
        uid,
        title,
        type,
        urlHtml5,
        urlHdHtml5,
        fmsUrl,
        url,
        urlHD,
        params,
        thumb,
        published) VALUES(
        ' . $user->uid . ',
        "' . $video_title . '",
        "' . $video_type . '",
        "' . $video_url_html5 . '",
        "' . $video_url_hd_html5 . '",
        "' . $video_fms_url . '",
        "' . $video_url . '",
        "' . $video_url_hd . '",
        "' . $video_params . '",
        "' . $video_thumb . '",
        ' . $video_published . ')');
  }
  drupal_set_message(t('Your video successfully saved.'), 'status', FALSE);
  $form_state['redirect'] = url('admin/settings/spider_video_player/videos', array('absolute' => TRUE));
}

/**
 * Apply video.
 */
function spider_video_player_video_apply($form, &$form_state) {
  global $user;
  $video_title = $form_state['values']['video_title'];
  $video_type = check_plain($_POST['video_radio_type_hidden']);
  switch ($video_type) {
    case 'http':
      $video_url = check_plain($_POST['url_http']);
      $video_url_hd = check_plain($_POST['urlHD']);
      $video_url_html5 = check_plain($_POST['urlHtml5']);
      $video_url_hd_html5 = check_plain($_POST['urlHdHtml5']);
      $video_fms_url = '';
      break;

    case 'youtube':
      $video_url = check_plain($_POST['video_youtube_url']);
      $video_url_hd = '';
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = '';
      break;

    case 'rtmp':
      $video_url = check_plain($_POST['video_rtmp_Url']);
      $video_url_hd = check_plain($_POST['video_rtmp_urlHD']);
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = check_plain($_POST['video_fmsUrl']);
      break;

    default:
      $video_url = '';
      $video_url_hd = '';
      $video_url_html5 = '';
      $video_url_hd_html5 = '';
      $video_fms_url = '';
      break;
  }
  $video_thumb = check_plain($_POST['thumb']);
  $result = db_query("SELECT id FROM {spider_video_player_tag} WHERE published='%d' ORDER BY ordering", 1);
  $tag_ids = array();
  while ($a = db_fetch_array($result)) {
    $tag_ids[] = $a['id'];
  }
  $video_params = '';
  foreach ($tag_ids as $tag_id) {
    $video_params .= $tag_id . '#===#' . $form_state['values']['video_param_' . $tag_id] . '#***#';
  }
  $video_published = $form_state['values']['video_published'];
  if (isset($_GET['video_id'])) {
    $video_id = check_plain($_GET['video_id']);
    db_query("UPDATE {spider_video_player_video} SET 
      uid='%d',
      title='%s',
      type='%s',
      urlHtml5='%s',
      urlHdHtml5='%s',
      fmsUrl='%s',
      url='%s',
      urlHD='%s',
      params='%s',
      thumb='%s',
      published='%d' WHERE id='%d'", 
      $user->uid,
      $video_title,
      $video_type,
      $video_url_html5,
      $video_url_hd_html5,
      $video_fms_url,
      $video_url,
      $video_url_hd,
      $video_params,
      $video_thumb,
      $video_published,
      $video_id);
    drupal_set_message(t('Your video successfully updated.'), 'status', FALSE);
  }
  else {
    db_query('INSERT INTO {spider_video_player_video} (
        uid,
        title,
        type,
        urlHtml5,
        urlHdHtml5,
        fmsUrl,
        url,
        urlHD,
        params,
        thumb,
        published) VALUES(
        ' . $user->uid . ',
        "' . $video_title . '",
        "' . $video_type . '",
        "' . $video_url_html5 . '",
        "' . $video_url_hd_html5 . '",
        "' . $video_fms_url . '",
        "' . $video_url . '",
        "' . $video_url_hd . '",
        "' . $video_params . '",
        "' . $video_thumb . '",
        ' . $video_published . ')');
    $video_id = db_result(db_query("SELECT MAX(id) FROM {spider_video_player_video}"));
    drupal_set_message(t('Your video successfully saved.'), 'status', FALSE);
  }
  $form_state['redirect'] = url('admin/settings/spider_video_player/videos/edit', array('query' => 'video_id=' . $video_id, 'absolute' => TRUE));
}

/**
 * Cancel video save.
 */
function spider_video_player_video_cancel() {
  drupal_goto(url('admin/settings/spider_video_player/videos', array('absolute' => TRUE)));
}
