<?php

/**
 * @file
 * Views handler to display the content of a Spider Video Player.
 */

/**
 * Field handler to present the Video Player to the user.
 */
class spider_video_player_handler_field_player_view extends views_handler_field {
  function construct() {
    parent::construct();
    $this->additional_fields['nid'] = 'nid';
  }
  function option_definition() {
    $options = parent::option_definition();
    $options['label'] = array('default' => 'Player', 'translatable' => TRUE);
    return $options;
  }
  function query() {
    $this->ensure_my_table();
    $this->add_additional_fields();
  }
  function render($values) {
    $node = node_load($values->{$this->aliases['nid']});
    if (node_access('view', $node)) {
      // Populate $node->content['spider_video_player'] by reference.
      spider_video_player_view($node, FALSE, FALSE);
      $video_player = isset($node->content['spider_video_player']['#value']) ? $node->content['spider_video_player']['#value'] : NULL;
    }
    else {
      return;
    }
    if (strpos(check_plain($_GET['q']), 'view')) {
      return NULL;
    }
    else {
      return $video_player;
    }
  }
}
